#include <Servo.h>

Servo s1, s2, s3;

char incomingByte; 

//int  LED = 12; 

int i[9] = {0,0,0,0,0,0};

boolean mt[8];

struct MOTOR    // структура для хранения номеров pin-ов, к которым подключены моторчики
{
  int in1;      // INPUT1
  int in2;      // INPUT2
};

// определяем порты, к которым подключены моторчики
MOTOR MOTOR1 = { 3,  4};
MOTOR MOTOR2 = { 18, 19};

int M1INP = 4;
int M1OUT = 3;
int M2INP = 15;
int M2OUT = 18;
 
void setup() {
  Serial.begin(9600); 
  s1.attach(9);
  s2.attach(10);
  s3.attach(11);
  s1.write(90);
  s2.write(90);
  s3.write(90);
  pinMode(MOTOR1.in1, OUTPUT); // настраиваем выводы
  pinMode(MOTOR1.in2, OUTPUT); // на ВЫВОД
  pinMode(MOTOR2.in1, OUTPUT);
  pinMode(MOTOR2.in2, OUTPUT);
  //pinMode(LED, OUTPUT);
}

void forward1() // первый вперёд
{
  digitalWrite(MOTOR1.in1, HIGH);
  digitalWrite(MOTOR1.in2, LOW);
}

void forward2() // второй вперёд
{
  digitalWrite(MOTOR2.in1, HIGH);
  digitalWrite(MOTOR2.in2, LOW);
}

void back1() // первый назад
{
  digitalWrite(MOTOR1.in1, LOW);
  digitalWrite(MOTOR1.in2, HIGH);
}

void back2() // второй назад
{
  digitalWrite(MOTOR2.in1, LOW);
  digitalWrite(MOTOR2.in2, HIGH);
}

void stop12() // второй назад
{
  digitalWrite(MOTOR2.in1, LOW);
  digitalWrite(MOTOR2.in2, LOW);
  digitalWrite(MOTOR1.in1, LOW);
  digitalWrite(MOTOR1.in2, LOW);
}
 
void loop() {
  if (Serial.available() > 0) {  
    incomingByte = Serial.read(); 
    if(incomingByte == '0' && i[0] != 180) {
       i[0]+=5;
    }
    if(incomingByte == '1' && i[0] != 0) {
       i[0]-=5;
    }
    if(incomingByte == '2' && i[1] != 180) {
       i[1]+=14;
    }
    if(incomingByte == '3'  && i[1] != 0) {
       i[1]-=14 ;
    }
    if(incomingByte == '4' && i[2] != 180) {
       i[2]+=5;
    }
    if(incomingByte == '5'  && i[2] != 0) {
       i[2]-=5;
    }
    if(incomingByte == '6' && mt[3] == false) {
       mt[3] = true;
    }else mt[3] = false;
    if(incomingByte == '7' && mt[2] == false) {
       mt[2] = true;
    }else mt[2] = false;
    if(incomingByte == 'C' && mt[5] == false) {
       mt[5] = true;
    }else mt[5] = false;
    if(incomingByte == 'D' && mt[6] == false) {
       mt[6] = true;
    }else mt[6] = false;
    if(incomingByte == '8' && mt[7] == false) {
       mt[7] = true;
    }else mt[7] = false;
    if(incomingByte == '9' && mt[0] == false) {
       mt[0] = true;
    }else mt[0] = false;
    if(incomingByte == 'A' && mt[1] == false) {
       mt[1] = true;
    }else mt[1] = false;
    if(incomingByte == 'B' && mt[4] == false) {
       mt[4] = true;
    }else mt[4] = false;
  }
  if (mt[0]) {
    back1();   // вращаем оба моторчика вперёд
    back2();
  }
  if (mt[1]) {
    forward1(); 
    forward2();   // вращаем оба моторчика вперёд
  }
  if (mt[2]) {
    forward1(); 
    back2();    
  }
  if (mt[3]) {
    forward2();
   back1(); 
  }
  if (mt[4]) {
    stop12();
  }
  if (mt[7]) {
    digitalWrite(12, HIGH);
  }
   if (mt[6]) {
    digitalWrite(12, LOW);
  }
  Serial.println(incomingByte);
  s1.write(i[0]);
  s2.write(i[1]);
  s3.write(i[2]);
}
